using System;
using NUnit.Framework;

namespace FizzBuzzKata.Tests
{
    public class FizzBuzzTests
    {
        [Test]
        [TestCase(0, "")]
        [TestCase(1, "1")]
        [TestCase(2, "1, 2")]
        [TestCase(3, "1, 2, Fizz")]
        [TestCase(5, "1, 2, Fizz, 4, Buzz")]
        [TestCase(16, "1, 2, Fizz, 4, Buzz, Fizz, 7, 8, Fizz, Buzz, 11, Fizz, 13, 14, FizzBuzz, 16")]
        public void GivenValidNumber_GenerateValidSequence(int length, string expectedResult)
        {
            var actualResult = FizzBuzz.Generate(length);
            Assert.AreEqual(expectedResult, actualResult);
        }


        [Test]
        [TestCase(-1)]
        public void GivenNumberLessThanZero_ThrowsException(int length)
        {
            Assert.That(() => FizzBuzz.Generate(length), Throws.TypeOf<ArgumentOutOfRangeException>());
        }
    }
}